## nng 1.7.2

=== CMakeLists.txt ===
#
#   Copyright 2024 Staysail Systems, Inc. <info@staysail.tech>
#   Copyright (c) 2012 Martin Sustrik  All rights reserved.
#   Copyright (c) 2013 GoPivotal, Inc.  All rights reserved.
#   Copyright (c) 2015-2016 Jack R. Dunaway. All rights reserved.
#   Copyright 2016 Franklin "Snaipe" Mathieu <franklinmathieu@gmail.com>
#   Copyright 2018 Capitar IT Group BV <info@capitar.com>
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom
#   the Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included
#   in all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
#   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
#   IN THE SOFTWARE.
#

cmake_minimum_required(VERSION 3.13)

project(nng C)
include(CheckCCompilerFlag)
include(GNUInstallDirs)

set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

include(NNGHelpers)
include(NNGOptions)

set(CMAKE_C_STANDARD 99)
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}" isSystemDir)
if ("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
endif ("${isSystemDir}" STREQUAL "-1")

set(NNG_DESCRIPTION "High-Performance Scalability Protocols NextGen")
set(ISSUE_REPORT_MSG "Please consider opening an issue at https://github.com/nanomsg/nng")

# Determine library versions.
file(READ "include/nng/nng.h" nng_ver_h)
string(REGEX MATCH "NNG_MAJOR_VERSION ([0-9]*)" _ ${nng_ver_h})
set(NNG_MAJOR_VERSION ${CMAKE_MATCH_1})
string(REGEX MATCH "NNG_MINOR_VERSION ([0-9]*)" _ ${nng_ver_h})
set(NNG_MINOR_VERSION ${CMAKE_MATCH_1})
string(REGEX MATCH "NNG_PATCH_VERSION ([0-9]*)" _ ${nng_ver_h})
set(NNG_PATCH_VERSION ${CMAKE_MATCH_1})
string(REGEX MATCH "NNG_RELEASE_SUFFIX \"([a-z0-9]*)\"" _ ${nng_ver_h})
if (NOT ("${CMAKE_MATCH_1}" STREQUAL ""))
    set(NNG_PRERELEASE "-${CMAKE_MATCH_1}")
endif ()

set(NNG_ABI_SOVERSION 1)
set(NNG_ABI_VERSION "${NNG_MAJOR_VERSION}.${NNG_MINOR_VERSION}.${NNG_PATCH_VERSION}${NNG_PRERELEASE}")
set(NNG_PACKAGE_VERSION "${NNG_ABI_VERSION}")
message(STATUS "Configuring for NNG version ${NNG_ABI_VERSION}")

# User-defined options.

# This prefix is appended to by subdirectories, so that each test
# gets named based on where it is in the tree.
set(NNG_TEST_PREFIX nng)

# Enable access to private APIs for our own use.
add_definitions(-DNNG_PRIVATE)

if (NOT (BUILD_SHARED_LIBS))
    set(NNG_STATIC_LIB ON)
    message(STATUS "Building static libs.")
endif ()

# These are library targets.  The "nng" library is the main public library.
# The "nng_testing" is a full build of the library for test cases
# only, which is done statically and includes even portions of the code
# that are not part of the public library (things that may have been elided.)
# The "nng_private" library is an interface that allows some internal tools
# to obtain details about how the public library was built, so that we can
# include or not include code based on what's actually present.
add_library(nng)

add_library(nng_testing STATIC EXCLUDE_FROM_ALL)
target_compile_definitions(nng_testing PUBLIC NNG_STATIC_LIB NNG_TEST_LIB NNG_PRIVATE)

add_library(nng_private INTERFACE)
target_compile_definitions(nng_private INTERFACE NNG_PRIVATE)

if (NNG_ELIDE_DEPRECATED)
    target_compile_definitions(nng PRIVATE NNG_ELIDE_DEPRECATED)
endif()
if (NNG_ENABLE_COMPAT)
    target_compile_definitions(nng PRIVATE NNG_ENABLE_COMPAT)
endif()


# We can use rlimit to configure the stack size for systems
# that have too small defaults.  This is not used for Windows,
# which can grow thread stacks sensibly.  (Note that NNG can get
# by with a smallish stack, but application callbacks might require
# larger values if using aio completion callbacks.  TLS libraries may
# require larger stacks however.)
if (NOT WIN32)
    option(NNG_SETSTACKSIZE "Use rlimit for thread stack size" OFF)
    if (NNG_SETSTACKSIZE)
        add_definitions(-DNNG_SETSTACKSIZE)
    endif ()
    mark_as_advanced(NNG_SETSTACKSIZE)
endif ()

nng_defines_if(NNG_ENABLE_STATS NNG_ENABLE_STATS)

set(NNG_RESOLV_CONCURRENCY 4 CACHE STRING "Resolver (DNS) concurrency.")
mark_as_advanced(NNG_RESOLV_CONCURRENCY)
if (NNG_RESOLV_CONCURRENCY)
    add_definitions(-DNNG_RESOLV_CONCURRENCY=${NNG_RESOLV_CONCURRENCY})
endif ()

set(NNG_NUM_TASKQ_THREADS 0 CACHE STRING "Fixed number of task threads, 0 for automatic")
mark_as_advanced(NNG_NUM_TASKQ_THREADS)
if (NNG_NUM_TASKQ_THREADS)
    add_definitions(-DNNG_NUM_TASKQ_THREADS=${NNG_NUM_TASKQ_THREADS})
endif ()

set(NNG_MAX_TASKQ_THREADS 16 CACHE STRING "Upper bound on task threads, 0 for no limit")
mark_as_advanced(NNG_MAX_TASKQ_THREADS)
if (NNG_MAX_TASKQ_THREADS)
    add_definitions(-DNNG_MAX_TASKQ_THREADS=${NNG_MAX_TASKQ_THREADS})
endif ()

# Expire threads. This runs the timeout handling, and having more of them
# reduces contention on the common locks used for aio expiration.
set(NNG_NUM_EXPIRE_THREADS 0 CACHE STRING "Fixed number of expire threads, 0 for automatic")
mark_as_advanced(NNG_NUM_EXPIRE_THREADS)
if (NNG_NUM_EXPIRE_THREADS)
    add_definitions(-DNNG_NUM_EXPIRE_THREADS=${NNG_NUM_EXPIRE_THREADS})
endif ()

set(NNG_MAX_EXPIRE_THREADS 8 CACHE STRING "Upper bound on expire threads, 0 for no limit")
mark_as_advanced(NNG_MAX_EXPIRE_THREADS)
if (NNG_MAX_EXPIRE_THREADS)
    add_definitions(-DNNG_MAX_EXPIRE_THREADS=${NNG_MAX_EXPIRE_THREADS})
endif()

# Poller threads.  These threads run the pollers.  This is mostly used
# on Windows right now, as the POSIX platforms use a single threaded poller.
set(NNG_NUM_POLLER_THREADS 0 CACHE STRING "Fixed number of I/O poller threads, 0 for automatic")
if (NNG_NUM_POLLER_THREADS)
    add_definitions(-DNNG_NUM_POLLER_THREADS=${NNG_NUM_POLLER_THREADS})
endif ()
mark_as_advanced(NNG_NUM_POLLER_THREADS)

set(NNG_MAX_POLLER_THREADS 8 CACHE STRING "Upper bound on I/O poller threads, 0 for no limit")
mark_as_advanced(NNG_MAX_POLLER_THREADS)
if (NNG_MAX_POLLER_THREADS)
    add_definitions(-DNNG_MAX_POLLER_THREADS=${NNG_MAX_POLLER_THREADS})
endif()

#  Platform checks.

if (CMAKE_C_COMPILER_ID STREQUAL "GNU")
    set(NNG_WARN_FLAGS "-Wall -Wextra -fno-omit-frame-pointer")
elseif (CMAKE_C_COMPILER_ID MATCHES "Clang")
    set(NNG_WARN_FLAGS "-Wall -Wextra -fno-omit-frame-pointer")
endif ()

include(CheckSanitizer)
CheckSanitizer()
if (NOT NNG_SANITIZER STREQUAL "none")
    set(NNG_SANITIZER_FLAGS "-fsanitize=${NNG_SANITIZER}")
endif ()

if (NNG_ENABLE_COVERAGE)
    # NB: This only works for GCC and Clang 3.0 and newer.  If your stuff
    # is older than that, you will need to find something newer.  For
    # correct reporting, we always turn off all optimizations.
    if (CMAKE_C_COMPILER_ID STREQUAL "GNU")
        set(NNG_COVERAGE_C_FLAGS "-g -O0 --coverage")
        set(CMAKE_SHARED_LINKER_FLAGS --coverage)
    elseif (CMAKE_C_COMPILER_ID MATCHES "Clang")
        set(NNG_COVERAGE_C_FLAGS "-g -O0 --coverage")
        set(CMAKE_SHARED_LINKER_FLAGS --coverage)
    else ()
        message(FATAL_ERROR "Unable to enable coverage for your compiler.")
    endif ()
endif ()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${NNG_WARN_FLAGS} ${NNG_COVERAGE_C_FLAGS} ${NNG_SANITIZER_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${NNG_WARN_FLAGS} ${NNG_COVERAGE_C_FLAGS} ${NNG_SANITIZER_FLAGS}")

# If the compiler is not on Windows, does it support hiding the
# symbols by default?  For shared libraries we would like to do this.
if (NOT WIN32 AND NOT CYGWIN)
    check_c_compiler_flag(-fvisibility=hidden NNG_HIDDEN_VISIBILITY)
    if (NNG_HIDDEN_VISIBILITY)
        add_definitions(-DNNG_HIDDEN_VISIBILITY)
    endif ()
endif ()

if (CMAKE_SYSTEM_NAME MATCHES "Linux")
    add_definitions(-DNNG_PLATFORM_POSIX)
    add_definitions(-DNNG_PLATFORM_LINUX)
    add_definitions(-DNNG_USE_EVENTFD)
    add_definitions(-DNNG_HAVE_ABSTRACT_SOCKETS)
    # Windows subsystem for Linux -- smells like Linux, but it has
    # some differences (SO_REUSEADDR for one).
    if (CMAKE_SYSTEM_VERSION MATCHES "Microsoft")
        add_definitions(-DNNG_PLATFORM_WSL)
    endif ()
    set(NNG_PLATFORM_POSIX ON)

elseif (CMAKE_SYSTEM_NAME MATCHES "Android")
    add_definitions(-DNNG_PLATFORM_POSIX)
    add_definitions(-DNNG_PLATFORM_LINUX)
    add_definitions(-DNNG_PLATFORM_ANDROID)
    add_definitions(-DNNG_USE_EVENTFD)
    set(NNG_PLATFORM_POSIX ON)

elseif (APPLE)
    add_definitions(-DNNG_PLATFORM_POSIX)
    add_definitions(-DNNG_PLATFORM_DARWIN)
    set(NNG_PLATFORM_POSIX ON)

elseif (CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
    add_definitions(-DNNG_PLATFORM_POSIX)
    add_definitions(-DNNG_PLATFORM_FREEBSD)
    set(NNG_PLATFORM_POSIX ON)

elseif (CMAKE_SYSTEM_NAME MATCHES "NetBSD")
    add_definitions(-DNNG_PLATFORM_POSIX)
    add_definitions(-DNNG_PLATFORM_NETBSD)
    set(NNG_PLATFORM_POSIX ON)

elseif (CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
    add_definitions(-DNNG_PLATFORM_POSIX)
    add_definitions(-DNNG_PLATFORM_OPENBSD)
    set(NNG_PLATFORM_POSIX ON)

elseif (CMAKE_SYSTEM_NAME MATCHES "SunOS")
    add_definitions(-DNNG_PLATFORM_POSIX)
    add_definitions(-DNNG_PLATFORM_SUNOS)
    set(NNG_PLATFORM_POSIX ON)

elseif (CMAKE_SYSTEM_NAME MATCHES "Windows")
    add_definitions(-DNNG_PLATFORM_WINDOWS)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    add_definitions(-D_CRT_RAND_S)
    set(NNG_PLATFORM_WINDOWS ON)

    # Target Windows Vista and later
    add_definitions(-D_WIN32_WINNT=0x0600)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -D_WIN32_WINNT=0x0600)

elseif (CMAKE_SYSTEM_NAME MATCHES "QNX")
    add_definitions(-DNNG_PLATFORM_POSIX)
    add_definitions(-D__EXT_BSD)
    add_definitions(-D_QNX_SOURCE)
    add_definitions(-DNNG_PLATFORM_QNX)
    set(NNG_PLATFORM_POSIX ON)

else ()
    message(AUTHOR_WARNING "WARNING: This platform may not be supported: ${CMAKE_SYSTEM_NAME}")
    message(AUTHOR_WARNING "${ISSUE_REPORT_MSG}")
    # blithely hope for POSIX to work
    add_definitions(-DNNG_PLATFORM_POSIX)
    set(NNG_PLATFORM_POSIX ON)
endif ()

if (NNG_ENABLE_TLS)
    add_definitions(-DNNG_SUPP_TLS)
endif ()

if (NNG_TESTS)
    enable_testing()
    set(all_tests, "")
endif ()

add_subdirectory(src)

if (NNG_TESTS)
    add_subdirectory(tests)
endif ()

#  Build the tools

add_subdirectory(docs/man)

set(CPACK_PACKAGE_NAME ${PROJECT_NAME})
set(CPACK_PACKAGE_VERSION ${NNG_PACKAGE_VERSION})
set(CPACK_PACKAGE_CONTACT "nanomsg@freelists.org")
set(CPACK_PACKAGE_VENDOR "nanomsg.org")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "nanomsg next generation library")
set(CPACK_SOURCE_GENERATOR "TBZ2;TGZ;ZIP")
set(CPACK_SOURCE_IGNORE_FILES "/build/;/.git/;~$;${CPACK_SOURCE_IGNORE_FILES}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME
        "${PROJECT_NAME}-v${NNG_PACKAGE_VERSION}-src")
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.txt)
set(CPACK_PACKAGE_INSTALL_DIRECTORY "nng")
set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-v${NNG_PACKAGE_VERSION}")

add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
include(CPack)

=== tests/CMakeLists.txt ===
#
#   Copyright 2024 Staysail Systems, Inc. <info@staysail.tech>
#   Copyright 2018 Capitar IT Group BV <info@capitar.com>
#   Copyright (c) 2012 Martin Sustrik  All rights reserved.
#   Copyright (c) 2013 GoPivotal, Inc.  All rights reserved.
#   Copyright (c) 2015-2016 Jack R. Dunaway. All rights reserved.
#   Copyright 2016 Franklin "Snaipe" Mathieu <franklinmathieu@gmail.com>
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom
#   the Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included
#   in all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
#   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
#   IN THE SOFTWARE.
#

#  Build unit tests.

# Note that tests which depend on internal (not public) APIs are not
# enabled unless a static library is built.  This is because on some
# systems (e.g. Windows) we do not expose symbols that are not in the
# public API. (When CMake learns more about using mapfiles to suppress
# symbol visibility we will do this even more, to protect the namespace
# of the user.)

include_directories(AFTER SYSTEM ${PROJECT_SOURCE_DIR}/src)

# convey.c needs its own link to pthreads.
if (NOT WIN32)
    find_package(Threads)
    set(THRLIB Threads::Threads)
endif ()

if (NNG_TESTS)

    nng_check_sym(nl_langinfo langinfo.h NNG_HAVE_LANGINFO)
    if (NOT NNG_SANITIZER STREQUAL "none")
        set(TIMEOUT_FACTOR 2)
    else ()
        set(TIMEOUT_FACTOR 1)
    endif ()
    set(NNG_TEST_PORT 13000)
    macro(add_nng_test NAME TIMEOUT)
        add_executable(${NAME} ${NAME}.c convey.c)
        target_link_libraries(${NAME} nng_testing ${THRLIB})
        add_test(NAME nng.${NAME} COMMAND ${NAME} -v -p TEST_PORT=${NNG_TEST_PORT})
        math(EXPR TIMEOUT ${TIMEOUT}*${TIMEOUT_FACTOR})
        set_tests_properties(nng.${NAME} PROPERTIES TIMEOUT ${TIMEOUT})
        math(EXPR NNG_TEST_PORT "${NNG_TEST_PORT}+20")
    endmacro(add_nng_test)

    # Compatibility tests are only added if all of the legacy protocols
    # are present.  It's not worth trying to figure out which of these
    # should work and which shouldn't.
    macro(add_nng_compat_test NAME TIMEOUT)
        add_executable(${NAME} ${NAME}.c compat_testutil.c)
        target_link_libraries(${NAME} nng_testing)
        target_include_directories(${NAME} PRIVATE
                ${PROJECT_SOURCE_DIR}/src/compat
                ${PROJECT_SOURCE_DIR}/include)
        add_test(NAME nng.${NAME} COMMAND ${NAME} ${NNG_TEST_PORT})
        set_tests_properties(nng.${NAME} PROPERTIES TIMEOUT ${TIMEOUT})
        math(EXPR NNG_TEST_PORT "${NNG_TEST_PORT}+20")
    endmacro(add_nng_compat_test)

    macro(add_nng_cpp_test NAME TIMEOUT)
        if (NOT NNG_ENABLE_COVERAGE)
            enable_language(CXX)
            add_executable(${NAME} ${NAME}.cc)
            target_link_libraries(${NAME} nng_testing)
            add_test(NAME nng.${NAME} COMMAND ${NAME} ${TEST_PORT})
            set_tests_properties(nng.${NAME} PROPERTIES TIMEOUT ${TIMEOUT})
            math(EXPR TEST_PORT "${NNG_TEST_PORT}+20")
        endif ()
    endmacro(add_nng_cpp_test)

    macro(add_nng_test1 NAME TIMEOUT COND1)
        if (${COND1})
            add_nng_test(${NAME} ${TIMEOUT})
        else ()
            message(STATUS "Test ${NAME} disabled (unconfigured)")
        endif ()
    endmacro()

    macro(add_nng_test2 NAME TIMEOUT COND1 COND2)
        if (${COND1} AND ${COND2})
            add_nng_test(${NAME} ${TIMEOUT})
        else ()
            message(STATUS "Test ${NAME} disabled (unconfigured)")
        endif ()
    endmacro()

    macro(add_nng_test3 NAME TIMEOUT COND1 COND2 COND3)
        if (${COND1} AND ${COND2} AND ${COND3})
            add_nng_test(${NAME} ${TIMEOUT} ON)
        else ()
            message(STATUS "Test ${NAME} disabled (unconfigured)")
        endif ()
    endmacro()

else ()
    macro(add_nng_test NAME TIMEOUT)
    endmacro(add_nng_test)
    macro(add_nng_compat_test NAME TIMEOUT)
    endmacro(add_nng_compat_test)
    macro(add_nng_cpp_test NAME TIMEOUT)
    endmacro(add_nng_cpp_test)
    macro(add_nng_test1 NAME TIMEOUT COND1)
    endmacro(add_nng_test1)
    macro(add_nng_test2 NAME TIMEOUT COND1 COND2)
    endmacro(add_nng_test2)
    macro(add_nng_test3 NAME TIMEOUT COND1 COND2 COND3)
    endmacro(add_nng_test3)
endif ()

add_nng_test(device 5)
add_nng_test(files 5)
add_nng_test1(httpclient 60 NNG_SUPP_HTTP)
add_nng_test1(httpserver 30 NNG_SUPP_HTTP)
add_nng_test(inproc 5)
add_nng_test(ipc 5)
add_nng_test(ipcsupp 10)
add_nng_test(multistress 60)
add_nng_test(nonblock 60)
add_nng_test(options 5)
add_nng_test(pipe 5)
add_nng_test(pollfd 5)
add_nng_test(scalability 20 ON)
add_nng_test(synch 5)
add_nng_test(tls 60)
add_nng_test(tcpsupp 10)
add_nng_test(tcp 180)
add_nng_test(tcp6 60)
add_nng_test(udp 5)
add_nng_test(ws 30)
add_nng_test(wss 30)
add_nng_test1(zt 60 NNG_TRANSPORT_ZEROTIER)

add_nng_test(reqctx 5)
add_nng_test(reqstress 60)

# compatibility tests
# We only support these if ALL the legacy protocols are supported.  This
# is because we don't want to make modifications to partially enable some
# of these tests.  Folks minimizing the library probably don't care too
# much about these anyway.
if (NNG_ENABLE_COMPAT)
    add_nng_compat_test(compat_block 10)
    add_nng_compat_test(compat_bug777 10)
    add_nng_compat_test(compat_bus 10)
    add_nng_compat_test(compat_cmsg 10)
    add_nng_compat_test(compat_msg 10)
    add_nng_compat_test(compat_iovec 10)
    add_nng_compat_test(compat_device 10)
    add_nng_compat_test(compat_pair 10)
    add_nng_compat_test(compat_pipeline 10)
    add_nng_compat_test(compat_poll 10)
    add_nng_compat_test(compat_reqrep 10)
    add_nng_compat_test(compat_survey 10)
    add_nng_compat_test(compat_reqttl 10)
    add_nng_compat_test(compat_shutdown 10)
    add_nng_compat_test(compat_surveyttl 10)

    # These are special tests for compat mode, not inherited from the
    # legacy libnanomsg suite.
    add_nng_test(compat_options 5)
endif()

# c++ tests
add_nng_cpp_test(cplusplus_pair 5)

=== demo/pubsub_forwarder/CMakeLists.txt ===
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.

cmake_minimum_required(VERSION 3.10)
project(pubsub_forwarder C)

# Find the nng library
find_package(nng REQUIRED)

# Add the executable target
add_executable(pubsub_forwarder pubsub_forwarder.c)

target_compile_options(pubsub_forwarder PRIVATE -Wall -Wextra -Wpedantic -Werror -O2)

# Link against the nng library
target_link_libraries(pubsub_forwarder PRIVATE nng)

=== docs/man/CMakeLists.txt ===
#
# Copyright 2020 Staysail Systems, Inc. <info@staysail.tech>
# Copyright 2018 Capitar IT Group BV <info@capitar.com>
# Copyright 2019 Devolutions <info@devolutions.net>
#
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.

# We default to off here.
option(NNG_ENABLE_DOC "Enable building documentation." OFF)

if (NNG_ENABLE_DOC)
    find_program(ASCIIDOCTOR asciidoctor)
    if (NOT ASCIIDOCTOR)
        message(WARNING "Could not find asciidoctor: skipping docs")
        set(NNG_ENABLE_DOC OFF)
    else ()
        message(STATUS "Using asciidoctor at ${ASCIIDOCTOR}")
    endif ()
endif ()

if (NNG_ENABLE_DOC)
    set(NNG_DOCDIR ${CMAKE_CURRENT_SOURCE_DIR})

    set(NNG_A2M ${ASCIIDOCTOR} -b manpage -amanmanual='NNG Reference Manual')
    set(NNG_A2H ${ASCIIDOCTOR} -a nofooter -atoc=left -aicons=font -d manpage -b html5)

    macro(nng_man NAME SECT)

        add_custom_command(
                OUTPUT ${NAME}.${SECT}
                COMMAND ${NNG_A2M} -o ${NAME}.${SECT} ${NNG_DOCDIR}/${NAME}.${SECT}.adoc
                MAIN_DEPENDENCY ${NNG_DOCDIR}/${NAME}.${SECT}.adoc
        )

        add_custom_command(
                OUTPUT ${NAME}.${SECT}.html
                COMMAND ${NNG_A2H} -o ${NAME}.${SECT}.html ${NNG_DOCDIR}/${NAME}.${SECT}.adoc
                MAIN_DEPENDENCY ${NNG_DOCDIR}/${NAME}.${SECT}.adoc
        )

        set(NNG_MANS ${NNG_MANS} ${NAME}.${SECT})
        set(NNG_HTMLS ${NNG_HTMLS} ${NAME}.${SECT}.html)

        install(
                FILES ${CMAKE_CURRENT_BINARY_DIR}/${NAME}.${SECT}.html
                DESTINATION ${CMAKE_INSTALL_DOCDIR}
        )
        install(
                FILES ${CMAKE_CURRENT_BINARY_DIR}/${NAME}.${SECT}
                DESTINATION ${CMAKE_INSTALL_MANDIR}/man${SECT}
        )

    endmacro(nng_man)

    set(NNG_MAN1
            nngcat
            )

    set(NNG_MAN3
            libnng
            nng_aio_abort
            nng_aio_alloc
            nng_aio_begin
            nng_aio_cancel
            nng_aio_count
            nng_aio_defer
            nng_aio_finish
            nng_aio_free
            nng_aio_get_input
            nng_aio_get_msg
            nng_aio_get_output
            nng_aio_result
            nng_aio_set_input
            nng_aio_set_iov
            nng_aio_set_msg
            nng_aio_set_output
            nng_aio_set_timeout
            nng_aio_stop
            nng_aio_wait
            nng_alloc
            nng_bus_open
            nng_close
            nng_ctx_close
            nng_ctx_get
            nng_ctx_getopt
            nng_ctx_id
            nng_ctx_open
            nng_ctx_recv
            nng_ctx_send
            nng_ctx_set
            nng_ctx_setopt
            nng_device
            nng_dial
            nng_dialer_close
            nng_dialer_create
            nng_dialer_get
            nng_dialer_getopt
            nng_dialer_id
            nng_dialer_set
            nng_dialer_setopt
            nng_dialer_start
            nng_free
            nng_getopt
            nng_inproc_register
            nng_ipc_register
            nng_listen
            nng_listener_close
            nng_listener_create
            nng_listener_get
            nng_listener_getopt
            nng_listener_id
            nng_listener_set
            nng_listener_setopt
            nng_listener_start
            nng_msg_alloc
            nng_msg_append
            nng_msg_body
            nng_msg_chop
            nng_msg_clear
            nng_msg_dup
            nng_msg_free
            nng_msg_get_pipe
            nng_msg_header
            nng_msg_header_append
            nng_msg_header_chop
            nng_msg_header_clear
            nng_msg_header_insert
            nng_msg_header_len
            nng_msg_header_trim
            nng_msg_insert
            nng_msg_len
            nng_msg_realloc
            nng_msg_set_pipe
            nng_msg_trim
            nng_pair_open
            nng_pipe_close
            nng_pipe_dialer
            nng_pipe_get
            nng_pipe_getopt
            nng_pipe_id
            nng_pipe_listener
            nng_pipe_notify
            nng_pipe_socket
            nng_pub_open
            nng_pull_open
            nng_push_open
            nng_recv
            nng_recv_aio
            nng_recvmsg
            nng_rep_open
            nng_req_open
            nng_respondent_open
            nng_send
            nng_send_aio
            nng_sendmsg
            nng_setopt
            nng_sleep_aio
            nng_socket_id
            nng_socket_get
            nng_socket_set
            nng_stats_free
            nng_stats_get
            nng_stat_bool
            nng_stat_child
            nng_stat_desc
            nng_stat_find
            nng_stat_find_dialer
            nng_stat_find_listener
            nng_stat_find_socket
            nng_stat_name
            nng_stat_next
            nng_stat_string
            nng_stat_timestamp
            nng_stat_type
            nng_stat_unit
            nng_stat_value
            nng_strdup
            nng_strerror
            nng_strfree
            nng_sub_open
            nng_surveyor_open
            nng_tcp_register
            nng_tls_register
            nng_url_clone
            nng_url_free
            nng_url_parse
            nng_version
            nng_ws_register
            nng_wss_register
            nng_zt_register
            )

    set(NNG_MAN3COMPAT
            nn_allocmsg
            nn_bind
            nn_close
            nn_cmsg
            nn_connect
            nn_device
            nn_errno
            nn_freemsg
            nn_get_statistic
            nn_getsockopt
            nn_poll
            nn_reallocmsg
            nn_recv
            nn_recvmsg
            nn_send
            nn_sendmsg
            nn_setsockopt
            nn_shutdown
            nn_socket
            nn_strerror
            nn_term
            nng_compat
            )

    set(NNG_MAN3HTTP
            nng_http_client_alloc
            nng_http_client_connect
            nng_http_client_free
            nng_http_client_get_tls
            nng_http_client_set_tls
            nng_http_client_transact
            nng_http_conn_close
            nng_http_conn_read
            nng_http_conn_read_all
            nng_http_conn_read_req
            nng_http_conn_read_res
            nng_http_conn_transact
            nng_http_conn_write
            nng_http_conn_write_all
            nng_http_conn_write_req
            nng_http_conn_write_res
            nng_http_handler_alloc
            nng_http_handler_free
            nng_http_handler_get_data
            nng_http_handler_set_data
            nng_http_handler_set_host
            nng_http_handler_set_method
            nng_http_handler_set_tree
            nng_http_hijack
            nng_http_req_add_header
            nng_http_req_alloc
            nng_http_req_copy_data
            nng_http_req_del_header
            nng_http_req_free
            nng_http_req_get_data
            nng_http_req_get_header
            nng_http_req_get_method
            nng_http_req_get_uri
            nng_http_req_get_version
            nng_http_req_reset
            nng_http_req_set_data
            nng_http_req_set_header
            nng_http_req_set_method
            nng_http_req_set_uri
            nng_http_req_set_version
            nng_http_res_add_header
            nng_http_res_alloc
            nng_http_res_alloc_error
            nng_http_res_copy_data
            nng_http_res_del_header
            nng_http_res_free
            nng_http_res_get_data
            nng_http_res_get_header
            nng_http_res_get_reason
            nng_http_res_get_status
            nng_http_res_get_version
            nng_http_res_reset
            nng_http_res_set_data
            nng_http_res_set_header
            nng_http_res_set_reason
            nng_http_res_set_status
            nng_http_res_set_version
            nng_http_server_add_handler
            nng_http_server_del_handler
            nng_http_server_get_addr
            nng_http_server_get_tls
            nng_http_server_hold
            nng_http_server_release
            nng_http_server_set_tls
            nng_http_server_start
            nng_http_server_stop
            )

    set(NNG_MAN3SUPP
            nng_clock
            nng_cv_alloc
            nng_cv_free
            nng_cv_until
            nng_cv_wait
            nng_cv_wake
            nng_cv_wake1
            nng_id_map
            nng_msleep
            nng_mtx_alloc
            nng_mtx_free
            nng_mtx_lock
            nng_mtx_unlock
            nng_opts_parse
            nng_random
            nng_socket_pair
            nng_thread_create
            nng_thread_destroy
            nng_thread_set_name
            )

    set(NNG_MAN3STR
            nng_stream_close
            nng_stream_free
            nng_stream_get
            nng_stream_recv
            nng_stream_send
            nng_stream_set
            nng_stream_dialer_alloc
            nng_stream_dialer_close
            nng_stream_dialer_dial
            nng_stream_dialer_free
            nng_stream_dialer_get
            nng_stream_dialer_set
            nng_stream_listener_accept
            nng_stream_listener_alloc
            nng_stream_listener_close
            nng_stream_listener_free
            nng_stream_listener_get
            nng_stream_listener_listen
            nng_stream_listener_set
            )

    set(NNG_MAN3TLS
            nng_tls_config_alloc
            nng_tls_config_auth_mode
            nng_tls_config_ca_chain
            nng_tls_config_ca_file
            nng_tls_config_cert_key_file
            nng_tls_config_free
            nng_tls_config_hold
            nng_tls_config_own_cert
            nng_tls_config_server_name
            nng_tls_engine_description
            nng_tls_engine_fips_mode
            nng_tls_engine_name
            )

    set(NNG_MAN5
            nng_aio
            nng_ctx
            nng_dialer
            nng_duration
            nng_iov
            nng_listener
            nng_msg
            nng_options
            nng_pipe
            nng_sockaddr
            nng_sockaddr_abstract
            nng_sockaddr_in
            nng_sockaddr_in6
            nng_sockaddr_inproc
            nng_sockaddr_ipc
            nng_sockaddr_zt
            nng_socket
            nng_stat
            nng_url

            nng_stream
            nng_stream_dialer
            nng_stream_listener

            nng_tcp_options
            nng_ipc_options
            nng_tls_config
            nng_tls_engine
            nng_tls_options
            )

    set(NNG_MAN7
            nng
            nng_bus
            nng_inproc
            nng_ipc
            nng_pair
            nng_pub
            nng_pull
            nng_push
            nng_rep
            nng_req
            nng_respondent
            nng_socket
            nng_sub
            nng_surveyor
            nng_tcp
            nng_tls
            nng_ws
            nng_zerotier
            )

    foreach (F ${NNG_MAN1})
        nng_man(${F} 1)
    endforeach ()

    foreach (F ${NNG_MAN3})
        nng_man(${F} 3)
    endforeach ()

    foreach (F ${NNG_MAN3COMPAT})
        nng_man(${F} 3compat)
    endforeach ()

    foreach (F ${NNG_MAN3HTTP})
        nng_man(${F} 3http)
    endforeach ()

    foreach (F ${NNG_MAN3STR})
        nng_man(${F} 3str)
    endforeach ()

    foreach (F ${NNG_MAN3SUPP})
        nng_man(${F} 3supp)
    endforeach ()

    foreach (F ${NNG_MAN3TLS})
        nng_man(${F} 3tls)
    endforeach ()

    foreach (F ${NNG_MAN5})
        nng_man(${F} 5)
    endforeach ()

    foreach (F ${NNG_MAN7})
        nng_man(${F} 7)
    endforeach ()

=== src/core/CMakeLists.txt ===
#
# Copyright 2024 Staysail Systems, Inc. <info@staystail.tech>
#
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.
#

#  Core.
nng_directory(core)

nng_check_sym(strlcpy string.h NNG_HAVE_STRLCPY)
nng_check_sym(strnlen string.h NNG_HAVE_STRNLEN)
nng_check_sym(strcasecmp string.h NNG_HAVE_STRCASECMP)
nng_check_sym(strncasecmp string.h NNG_HAVE_STRNCASECMP)

nng_sources(
        defs.h

        aio.c
        aio.h
        device.c
        device.h
        dialer.c
        dialer.h
        sockfd.c
        sockfd.h
        file.c
        file.h
        idhash.c
        idhash.h
        init.c
        init.h
        list.c
        list.h
        listener.c
        listener.h
        lmq.c
        lmq.h
        message.c
        message.h
        msgqueue.c
        msgqueue.h
        nng_impl.h
        options.c
        options.h
        pollable.c
        pollable.h
        panic.c
        panic.h
        pipe.c
        pipe.h
        platform.h
        protocol.h
        reap.c
        reap.h
        socket.c
        socket.h
        sockimpl.h
        stats.c
        stats.h
        stream.c
        stream.h
        strs.c
        strs.h
        taskq.c
        taskq.h
        tcp.c
        tcp.h
        thread.c
        thread.h
        url.c
        url.h
)

nng_test(aio_test)
nng_test(buf_size_test)
nng_test(errors_test)
nng_test(id_test)
nng_test(init_test)
nng_test(list_test)
nng_test(message_test)
nng_test(reconnect_test)
nng_test(sock_test)
nng_test(stats_test)
nng_test(url_test)

=== src/platform/CMakeLists.txt ===
#
# Copyright 2020 Staysail Systems, Inc. <info@staystail.tech>
#
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.
#

#  Platforms.
nng_directory(platform)

add_subdirectory(posix)
add_subdirectory(windows)

nng_test(platform_test)
nng_test(resolver_test)

=== src/sp/CMakeLists.txt ===
#
# Copyright 2021 Staysail Systems, Inc. <info@staystail.tech>
#
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.
#

nng_directory(sp)

add_subdirectory(protocol)
add_subdirectory(transport)

nng_sources(
        protocol.c
        transport.c
        transport.h
)

=== src/platform/posix/CMakeLists.txt ===
#
# Copyright 2023 Staysail Systems, Inc. <info@staystail.tech>
#
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.
#

#  POSIX.

# We cannot use nng_sources_if because these tests don't go into
# the static library unless they also go into the dynamic.
if (NNG_PLATFORM_POSIX)

    nng_find_package(Threads)
    nng_link_libraries(Threads::Threads)

    # Unconditionally declare the following feature test macros.  These are
    # needed for some platforms (glibc and SunOS/illumos) and are harmless
    # on the others.
    nng_defines(_GNU_SOURCE)
    nng_defines(_REENTRANT)
    nng_defines(_THREAD_SAFE)
    nng_defines(_POSIX_PTHREAD_SEMANTICS)

    nng_check_func(lockf NNG_HAVE_LOCKF)
    nng_check_func(flock NNG_HAVE_FLOCK)
    nng_check_func(getrandom NNG_HAVE_GETRANDOM)
    nng_check_func(arc4random_buf NNG_HAVE_ARC4RANDOM)

    nng_check_lib(rt clock_gettime NNG_HAVE_CLOCK_GETTIME)
    nng_check_lib(pthread sem_wait NNG_HAVE_SEMAPHORE_PTHREAD)
    nng_check_lib(pthread pthread_atfork NNG_HAVE_PTHREAD_ATFORK_PTHREAD)
    nng_check_lib(pthread pthread_set_name_np NNG_HAVE_PTHREAD_SET_NAME_NP)
    nng_check_lib(pthread pthread_setname_np NNG_HAVE_PTHREAD_SETNAME_NP)
    nng_check_lib(nsl gethostbyname NNG_HAVE_LIBNSL)
    nng_check_lib(socket socket NNG_HAVE_LIBSOCKET)

    # GCC needs libatomic on some architectures (e.g. ARM) because the
    # underlying architecture may lack the necessary atomic primitives.
    # One hopes that the libatomic implementation is superior to just using
    # a pthread mutex.  The symbol chosen here was identified from GCC's
    # libatomic map file.
    #
    # Arguably when using clang, compiler-rt might be better.
    nng_check_lib(atomic __atomic_load_1 NNG_HAVE_LIBATOMIC)

    nng_check_sym(AF_UNIX sys/socket.h NNG_HAVE_UNIX_SOCKETS)
    nng_check_sym(backtrace_symbols_fd execinfo.h NNG_HAVE_BACKTRACE)
    nng_check_struct_member(msghdr msg_control sys/socket.h NNG_HAVE_MSG_CONTROL)
    nng_check_sym(eventfd sys/eventfd.h NNG_HAVE_EVENTFD)
    nng_check_sym(kqueue sys/event.h NNG_HAVE_KQUEUE)
    nng_check_sym(port_create port.h NNG_HAVE_PORT_CREATE)
    nng_check_sym(epoll_create sys/epoll.h NNG_HAVE_EPOLL)
    nng_check_sym(epoll_create1 sys/epoll.h NNG_HAVE_EPOLL_CREATE1)
    nng_check_sym(getpeereid unistd.h NNG_HAVE_GETPEEREID)
    nng_check_sym(SO_PEERCRED sys/socket.h NNG_HAVE_SOPEERCRED)
    nng_check_struct_member(sockpeercred uid sys/socket.h NNG_HAVE_SOCKPEERCRED)
    nng_check_sym(LOCAL_PEERCRED sys/un.h NNG_HAVE_LOCALPEERCRED)
    nng_check_sym(LOCAL_PEERPID sys/un.h NNG_HAVE_LOCALPEERPID)
    nng_check_sym(getpeerucred ucred.h NNG_HAVE_GETPEERUCRED)
    nng_check_sym(atomic_flag_test_and_set stdatomic.h NNG_HAVE_STDATOMIC)
    nng_check_sym(socketpair sys/socket.h NNG_HAVE_SOCKETPAIR)

    nng_sources(
            posix_impl.h
            posix_aio.h
            posix_ipc.h
            posix_config.h
            posix_pollq.h
            posix_tcp.h

            posix_alloc.c
            posix_atomic.c
            posix_clock.c
            posix_debug.c
            posix_file.c
            posix_ipcconn.c
            posix_ipcdial.c
            posix_ipclisten.c
            posix_peerid.c
            posix_pipe.c
            posix_resolv_gai.c
            posix_sockaddr.c
            posix_socketpair.c
            posix_sockfd.c
            posix_tcpconn.c
            posix_tcpdial.c
            posix_tcplisten.c
            posix_thread.c
            posix_udp.c
    )

    if (NNG_HAVE_PORT_CREATE)
        nng_sources(posix_pollq_port.c)
    elseif (NNG_HAVE_KQUEUE)
        nng_sources(posix_pollq_kqueue.c)
    elseif (NNG_HAVE_EPOLL AND NNG_HAVE_EVENTFD)
        nng_sources(posix_pollq_epoll.c)
    else ()
        nng_sources(posix_pollq_poll.c)
    endif ()

    if (NNG_HAVE_ARC4RANDOM)
        nng_sources(posix_rand_arc4random.c)
    elseif (NNG_HAVE_GETRANDOM)
        nng_sources(posix_rand_getrandom.c)
    else ()
        nng_sources(posix_rand_urandom.c)
    endif ()

    nng_test(posix_ipcwinsec_test)

endif ()

=== src/platform/windows/CMakeLists.txt ===
#
# Copyright 2021 Staysail Systems, Inc. <info@staystail.tech>
#
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.
#

#  Windows.

# We cannot use nng_sources_if because these tests don't go into
# the static library unless they also go into the dynamic.
if (NNG_PLATFORM_WINDOWS)
    nng_check_sym(InitializeConditionVariable windows.h NNG_HAVE_CONDVAR)
    nng_check_sym(snprintf stdio.h NNG_HAVE_SNPRINTF)
    if (NOT NNG_HAVE_CONDVAR OR NOT NNG_HAVE_SNPRINTF)
        message(FATAL_ERROR
                "Modern Windows API support is missing. "
                "Versions of Windows prior to Vista are not supported.  "
                "Further, the 32-bit MinGW environment is not supported. "
                "Ensure you have at least Windows Vista or newer, and are "
                "using either Visual Studio 2013 or newer or MinGW-W64.")
    endif ()
    nng_link_libraries(ws2_32 mswsock advapi32)

    nng_sources(
            win_impl.h
            win_ipc.h
            win_tcp.h
            win_clock.c
            win_debug.c
            win_file.c
            win_io.c
            win_ipcconn.c
            win_ipcdial.c
            win_ipclisten.c
            win_pipe.c
            win_rand.c
            win_resolv.c
            win_sockaddr.c
            win_socketpair.c
            win_tcp.c
            win_tcpconn.c
            win_tcpdial.c
            win_tcplisten.c
            win_thread.c
            win_udp.c
    )

    nng_test(win_ipc_sec_test)

endif ()

=== src/supplemental/util/CMakeLists.txt ===
#
# Copyright 2024 Staysail Systems, Inc. <info@staysail.tech>
#
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.
#

nng_sources(idhash.c options.c platform.c)
nng_headers(
	nng/supplemental/util/idhash.h
	nng/supplemental/util/options.h
	nng/supplemental/util/platform.h)
nng_test(idhash_test)

=== src/tools/nngcat/CMakeLists.txt ===
#
# Copyright 2021 Staysail Systems, Inc. <info@staysail.tech>
# Copyright 2018 Capitar IT Group BV <info@capitar.com>
#
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.
#

nng_directory(nngcat)

if (NNG_ENABLE_NNGCAT)
    add_executable(nngcat nngcat.c)
    target_include_directories(nngcat PUBLIC ${PROJECT_SOURCE_DIR}/src)
    target_link_libraries(nngcat nng nng_private)
    install(TARGETS nngcat RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            COMPONENT Tools)

    if (NNG_TESTS AND CMAKE_SYSTEM_NAME MATCHES "Linux")
        include(FindUnixCommands)
    endif ()
    # TODO: This should be refactored to use a test driver.
    # We only run the tests on Linux for now, because the Darwin CI/CD is too brittle.
    if (NNG_TESTS AND BASH AND CMAKE_SYSTEM_NAME MATCHES "Linux")
        macro(add_nngcat_test NAME TIMEOUT)
            add_test(NAME nng.${NAME} COMMAND ${BASH} ${CMAKE_CURRENT_SOURCE_DIR}/${NAME}_test.sh $<TARGET_FILE:nngcat>)
            set_tests_properties(nng.${NAME} PROPERTIES TIMEOUT ${TIMEOUT})
        endmacro()
        add_nngcat_test(nngcat_async 10)
        add_nngcat_test(nngcat_ambiguous 10)
        add_nngcat_test(nngcat_need_proto 10)
        add_nngcat_test(nngcat_dup_proto 10)
        add_nngcat_test(nngcat_help 10)
        add_nngcat_test(nngcat_incompat 10)
        add_nngcat_test(nngcat_pubsub 20)
        add_nngcat_test(nngcat_recvmaxsz 20)
        add_nngcat_test(nngcat_unlimited 20)
        add_nngcat_test(nngcat_stdin_pipe 20)
    endif ()
endif ()

=== src/sp/transport/ws/CMakeLists.txt ===
#
# Copyright 2020 Staysail Systems, Inc. <info@staysail.tech>
# Copyright 2018 Capitar IT Group BV <info@capitar.com>
#
# This software is supplied under the terms of the MIT License, a
# copy of which should be located in the distribution where this
# file was obtained (LICENSE.txt).  A copy of the license may also be
# found online at https://opensource.org/licenses/MIT.
#

# WebSocket transport
nng_directory(ws)

if (NNG_TRANSPORT_WS OR NNG_TRANSPORT_WSS)
    set(WS_ON ON)
endif()

nng_defines_if(NNG_TRANSPORT_WS NNG_TRANSPORT_WS)
nng_defines_if(NNG_TRANSPORT_WSS NNG_TRANSPORT_WSS)
nng_sources_if(WS_ON websocket.c)
nng_headers_if(WS_ON nng/transport/ws/websocket.h)
nng_test_if(WS_ON ws_test)

=== debian/changelog ===
nng (1.7.2-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:15:39 +0000

nng (1.7.2-1build1) noble; urgency=medium

  * No-change rebuild against libmbedcrypto7t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 17 Mar 2024 18:10:37 +0000

nng (1.7.2-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 04 Feb 2024 08:48:51 +0100

=== debian/control ===
Source: nng
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: debhelper-compat (= 13), dh-python, cmake, scons, python3, protobuf-compiler, python3-protobuf, libmbedtls-dev
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://nng.nanomsg.org/

Package: nng-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: foreign
Description: Lightweight Messaging Library - utility
 Lightweight, broker-less library, offering a simple API to solve
 common recurring messaging problems, such as publish/subscribe,
 RPC-style request/reply, or service discovery. The API frees the
 programmer from worrying about details like connection management,
 retries, and other common considerations, so that they can focus on
 the application instead of the plumbing.
 .
 This package contains the nngcat utility.

Package: libnng1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Lightweight Messaging Library - shared library
 Lightweight, broker-less library, offering a simple API to solve
 common recurring messaging problems, such as publish/subscribe,
 RPC-style request/reply, or service discovery. The API frees the
 programmer from worrying about details like connection management,
 retries, and other common considerations, so that they can focus on
 the application instead of the plumbing.
 .
 This package contains the shared library.

Package: libnng-dev
Section: libdevel
Architecture: any
Depends: libnng1 (= ${binary:Version}), ${misc:Depends}, libmbedtls-dev
Multi-Arch: same
Description: Lightweight Messaging Library - development
 Lightweight, broker-less library, offering a simple API to solve
 common recurring messaging problems, such as publish/subscribe,
 RPC-style request/reply, or service discovery. The API frees the
 programmer from worrying about details like connection management,
 retries, and other common considerations, so that they can focus on
 the application instead of the plumbing.
 .
 This package contains the header files needed for developing programs
 using libwebsockets and a static library.

=== debian/rules ===
#!/usr/bin/make -f
#-*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

override_dh_auto_clean:
	$(RM) -r $(CURDIR)/build-shared
	$(RM) -r $(CURDIR)/build-static
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake --builddir=build-static \
		-- -DNNG_ENABLE_TLS=ON -DBUILD_SHARED_LIBS=OFF
	dh_auto_configure --buildsystem=cmake --builddir=build-shared \
		-- -DNNG_ENABLE_TLS=ON -DBUILD_SHARED_LIBS=ON

override_dh_auto_build:
	dh_auto_build --buildsystem=cmake --builddir=build-static
	dh_auto_build --buildsystem=cmake --builddir=build-shared

override_dh_auto_test:
	dh_auto_test --buildsystem=cmake --builddir=build-static
	dh_auto_test --buildsystem=cmake --builddir=build-shared

override_dh_auto_install:
	dh_auto_install --buildsystem=cmake --builddir=build-static
	dh_auto_install --buildsystem=cmake --builddir=build-shared

%:
	dh $@ --buildsystem=cmake

.PHONY: override_dh_auto_clean override_dh_auto_configure \
	override_dh_auto_build override_dh_auto_test override_dh_auto_install

=== debian/watch ===
version=4
https://github.com/nanomsg/nng/tags .*/v?(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
